package rs2;

import java.io.InputStream;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine.Info;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineEvent.Type;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;

//USED FOR THE SOUND EVENTS
import static javax.sound.sampled.LineEvent.Type.OPEN;
import static javax.sound.sampled.LineEvent.Type.STOP;

public class GameSoundPlayer implements LineListener {
	
	private Mixer mixer;
	private boolean errorLoadingMixer;
	
	public GameSoundPlayer() {
		mixer = AudioSystem.getMixer(null);
		if(mixer != null) {
			try {
				mixer.open();
				return;
			} catch (LineUnavailableException e) {
				e.printStackTrace();
			}
		}
		errorLoadingMixer = true;
		System.err.println("Error initlizing mixer!");
	}

	public void appendSound(InputStream sound) throws Exception {
		if(errorLoadingMixer) {
			throw new Exception("Mixer required!");
		}
		AudioInputStream stream = AudioSystem.getAudioInputStream(sound);
		Info lineInformation = new Info(Clip.class, stream.getFormat());
		if(mixer.isLineSupported(lineInformation)) {
			Clip clip = (Clip) AudioSystem.getLine(lineInformation);
			clip.addLineListener(this);
			clip.open(stream);
		}
	}

	@Override
	public void update(LineEvent line) {
		Type type = line.getType();
		Object source = line.getSource();
		if(!(source instanceof Clip)) {
			return;
		}
		Clip clip = (Clip) source;
		if(type == OPEN) {
			clip.start();
		} else if(type == STOP) {
			clip.close();
			line.getLine().close();
		}
	}
}