package rs2;

import java.io.File;
import java.io.IOException;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Sequencer;


/**
 * Used to handle music like 400+.
 * @author Ryan
 * @author Deathfire138
 */
public class Music {
	
	/** Variables **/
    public String midiFileName;
    public String midiSaveDir;
    public Sequencer sequencer;


    /** Music part for signlink **/
    public void sendMusic() {
    	String midiDir = midiFileName + midiSaveDir;
    	File midiFile = new File(midiDir);
    	try {
    		sequencer = MidiSystem.getSequencer();
    		sequencer.setSequence(MidiSystem.getSequence(midiFile));
    		sequencer.open();
    		sequencer.start();
    		if (sequencer.isRunning());
    		try {
    			Thread.sleep(1000L);
    		} catch (InterruptedException localInterruptedException) {
    			sequencer.stop();
    			sequencer.close(); 
    		}
    		} catch (MidiUnavailableException mue) {
    			System.out.println("Midi device unavailable!");
    		} catch (InvalidMidiDataException imde) {
    			System.out.println("Invalid Midi data!");
    		} catch (IOException ioe) {
    			System.out.println("I/O Error!");
    		}
    }
    
    /** Ends the music **/
    public void endMusic() {
    	//TODO Fade and then stop.
    }
    
    /** Loops the music **/
    public void loopMusic() {
    	sequencer.setLoopCount(Sequencer.LOOP_CONTINUOUSLY);
    }
}